// @link https://www.dataformsjs.com
// @version 5.2.0
// @author Conrad Sollitt (https://conradsollitt.com)
// @license MIT
const cachedValues={};window.Cache = class Cache{static get(e,a){return void 0===cachedValues[e]?a:cachedValues[e]}static set(e,a){cachedValues[e]=a}};
window.ErrorBoundary = class ErrorBoundary extends React.Component{constructor(e){super(e),this.state={error:null,errorInfo:null}}componentDidCatch(e,r){this.setState({error:e,errorInfo:r})}render(){return this.state.errorInfo?React.createElement("div",null,React.createElement("h2",{style:{textAlign:"left",color:"white",backgroundColor:"#bc0000",padding:"1em"}},"An error has occurred"),React.createElement("details",{style:{whiteSpace:"pre-wrap",textAlign:"left",color:"white",backgroundColor:"red",padding:"1em"}},this.state.error&&this.state.error.toString(),React.createElement("br",null),this.state.errorInfo.componentStack)):this.props.children}};
window.Format = class Format{number(r){return this.formatNumber(r,{})}currency(r,e){const t={style:"currency",currency:e,maximumFractionDigits:2};return this.formatNumber(r,t)}percent(r,e=0){const t={style:"percent",maximumFractionDigits:e,minimumFractionDigits:e};return this.formatNumber(r,t)}date(r){return this.formatDateTime(r,{})}dateTime(r){return this.formatDateTime(r,{year:"numeric",month:"numeric",day:"numeric",hour:"numeric",minute:"numeric",second:"numeric"})}time(r){return this.formatDateTime(r,{hour:"numeric",minute:"numeric",second:"numeric"})}isNumber(r){return!isNaN(parseFloat(r))&&isFinite(r)}formatDateTime(r,e){if(void 0===window.Intl)return r;try{if(r instanceof Date)return new Intl.DateTimeFormat(navigator.language,e).format(r);if(/^\d{4}-\d{2}-\d{2}$/.test(r)){const t=r.split("-").map((function(r){return parseInt(r,10)})),n=new Date(t[0],t[1]-1,t[2]);return new Intl.DateTimeFormat(navigator.language,e).format(n)}{const t=new Date(r);return new Intl.DateTimeFormat(navigator.language,e).format(t)}}catch(t){return console.warn("Error formatting Date/Time Value:"),console.log(navigator.language),console.log(e),console.log(r),console.log(t),"Error"}}formatNumber(r,e){const t=navigator.language?navigator.language:navigator.userLanguage;if(null===r||""===r)return null;if(!this.isNumber(r))return console.warn("Warning value specified in DateFormsJS function formatNumber() is not a number:"),console.log(r),r;if(void 0===window.Intl){const n=e.style?e.style:null,o=e.maximumFractionDigits?e.maximumFractionDigits:0;if("percent"===n)return(100*r).toFixed(o)+"%";let a=null,i=null,u=null;switch(t){case"en-us":a=",",i=".",u="$"}if(null!==a){const e=r.toString().split(".");e[0]=e[0].replace(/\B(?=(\d{3})+(?!\d))/g,",");const t=e.join(i);return"currency"===n?u+t:t}return r}try{return new Intl.NumberFormat(t,e).format(r)}catch(n){return console.warn("Error formatting Numeric Value:"),console.log(t),console.log(e),console.log(r),console.log(n),"Error"}}};
window.InputFilter = class InputFilter extends React.Component{constructor(t){super(t),this.onChange=this.onChange.bind(this),this.input=React.createRef()}componentDidMount(){this.filter()}onChange(){this.filter(),"function"==typeof this.props.afterFilter&&this.props.afterFilter()}filter(){const t=this.input.current,e=t.value.toLowerCase().split(" "),n=e.length,s=0!==n;let l=0,r=null,o=null,i=document.querySelectorAll(this.props["filter-selector"]);if(1===i.length&&"TABLE"===i[0].tagName&&i[0].tHead&&1===i[0].tHead.rows.length&&1===i[0].tBodies.length){const t=i[0];r=t.getAttribute("data-sort-class-odd"),o=t.getAttribute("data-sort-class-even"),i=i[0].tBodies[0].rows}const a=i.length,u=o&&r;for(let t=0,a=i.length;t<a;t++){const a=i[t];let c=!0;if(s){const t=a.textContent.toLowerCase();for(let s=0;s<n;s++)if(""!==e[s]&&!t.includes(e[s])){c=!1;break}}c&&(l++,u&&(l%2==0?(a.classList.add(o),a.classList.remove(r)):(a.classList.add(r),a.classList.remove(o)))),a.style.display=c?"":"none"}const c=t.getAttribute("filter-results-selector");if(c){const e=document.querySelector(c);if(!e)return void console.warn("Defined [filter-results-selector] but element not found");const n=t.getAttribute("filter-results-text-all"),s=t.getAttribute("filter-results-text-filtered");if(null===n&&null===s)return void console.warn("Defined [filter-results-selector] without [filter-results-text-all] or [filter-results-text-filtered]");let r=null;l===a?r=n:null!==s&&(r=s.replace(/{displayCount}/g,l)),null===r?e.textContent="":(r=r.replace(/{totalCount}/g,a),e.textContent=r)}}render(){return void 0!==window&&window.React===window.preact?React.createElement("input",Object.assign({},this.props,{onInput:this.onChange,ref:this.input})):React.createElement("input",Object.assign({},this.props,{onChange:this.onChange,ref:this.input}))}};
const jsonDataCache=[],graphQL_Cache={};function saveDataToCache(t,e,r,s){for(let a=0,i=jsonDataCache.length;a<i;a++){const i=jsonDataCache[a];if(i.url===t&&i.query===e)return i.params=JSON.stringify(r),void(i.data=s)}jsonDataCache.push({url:t,query:e,params:JSON.stringify(r),data:s})}function getDataFromCache(t,e,r){for(let s=0,a=jsonDataCache.length;s<a;s++){const a=jsonDataCache[s];if(a.url===t&&a.query===e){if(JSON.stringify(r)===a.params)return a.data;break}}return null}function IsLoading(t){return 0===t.fetchState&&t.children?t.children:null}function HasError(t){if(!(-1===t.fetchState)||!t.children)return null;let e=t.error;return"string"==typeof e&&-1===e.indexOf("Error")&&(e="Error - "+e),React.cloneElement(t.children,{error:e})}function IsLoaded(t){return 1===t.fetchState&&t.children?React.cloneElement(t.children,{data:t.data,params:t.params,handleChange:t.handleChange}):null}window.JsonData = class JsonData extends React.Component{constructor(t){super(t),this._isFetching=!1,this._isMounted=!1,this.fetchData=this.fetchData.bind(this),this.handleChange=this.handleChange.bind(this),this._querySrc=t&&t.querySrc?t.querySrc:void 0,this._query=t&&t.query?t.query:void 0,this.state={fetchState:0,error:null,params:this.getUrlParams(),data:null}}getUrlParams(){const t={};if(this.props&&!0===this.props.graphQL)return void 0===this.props.variables?{}:this.props.variables;for(const e in this.props)"url"!==e&&"string"==typeof this.props[e]&&(t[e]=this.props[e]);return t}componentDidMount(){if(this._isMounted=!0,!0===this.props.graphQL&&void 0===this._query&&void 0!==this._querySrc&&void 0!==graphQL_Cache[this._querySrc]&&(this._query=graphQL_Cache[this._querySrc]),this.props.loadOnlyOnce){const t=getDataFromCache(this.props.url,this._query,this.getUrlParams());if(null!==t)return void this.setState({fetchState:1,data:t})}if(!0!==this.props.graphQL||void 0!==this._query||void 0===this._querySrc)this.fetchData();else{const t=this._querySrc,e=this;fetch(t,null).then((t=>{const e=t.status;if(e>=200&&e<300||304===e)return Promise.resolve(t);{const r="Error loading data. Server Response Code: "+e+", Response Text: "+t.statusText;return Promise.reject(r)}})).then((t=>t.text())).then((function(r){graphQL_Cache[t]=r,e._query=graphQL_Cache[t],e.fetchData()})).catch((function(e){throw new Error("Error Downloading GraphQL Script: ["+t+"], Error: "+e.toString())}))}}componentDidUpdate(t,e){let r;if(!0===this.props.graphQL)r=JSON.stringify(t.variables)!==JSON.stringify(this.props.variables);else{r=this.buildUrl(e.params)!==this.buildUrl(this.props)}r&&this.setState({params:this.getUrlParams()},this.fetchData)}componentWillUnmount(){this._isMounted=!1}buildUrl(t){let e=this.props.url;if(!0!==this.props.graphQL&&Object.keys(t).length>0)for(var r in t)e.indexOf(":"+r)>-1&&(e=e.replace(new RegExp(":"+r,"g"),encodeURIComponent(t[r])));return e}fetchData(){let t=this.buildUrl(this.state.params);if(this._isFetching)return;this._isFetching=!0;let e={mode:"cors",cache:"no-store",credentials:"same-origin"};if(this.props.fetchOptions&&(e=this.props.fetchOptions),this.props.fetchHeaders&&(e.headers=this.props.fetchHeaders),!0===this.props.graphQL){const r=void 0===this.props.variables?{}:this.props.variables;"file://"===window.location.origin||"null"===window.location.origin?(t+=-1===t.indexOf("?")?"?":"&",t+="query="+encodeURIComponent(this._query.trim()),t+="&variables="+encodeURIComponent(JSON.stringify(r))):(e.method="POST",void 0===e.headers?e.headers={"Content-Type":"application/json"}:e.headers["Content-Type"]="application/json",e.body=JSON.stringify({query:this._query,variables:r}))}this.setState({fetchState:0},(()=>{this.updateView(),fetch(t,e).then((t=>{const e=t.status;if(e>=200&&e<300||304===e)return Promise.resolve(t);{const r="Error loading data. Server Response Code: "+e+", Response Text: "+t.statusText;return Promise.reject(r)}})).then((t=>t.json())).then((t=>{const e=!0===this.props.graphQL;if(e&&t.errors&&t.errors.length){let e;if(1===t.errors.length&&t.errors[0].message)e="[GraphQL Error]: "+t.errors[0].message;else{e=("string"==typeof this.props.errorTextGraphQLErrors?this.props.errorTextGraphQLErrors:"{count} GraphQL Errors occured. See console for full details.").replace("{count}",t.errors.length)}throw console.error(t.errors),e}this._isMounted&&this.setState({fetchState:1,data:e?t.data:t}),this.props.loadOnlyOnce&&saveDataToCache(this.props.url,this._query,this.getUrlParams(),e?t.data:t)})).catch((t=>{this._isMounted&&this.setState({fetchState:-1,error:t.toString()})})).finally((()=>{this._isFetching=!1,this.updateView()}))}))}handleChange(t=null){this._isMounted&&this.setState({data:null===t?this.state.data:t})}updateView(){if("function"==typeof this.props.onViewUpdated)try{this.props.onViewUpdated()}catch(t){console.error(t)}}render(){return React.createElement(React.Fragment,null,React.createElement(IsLoading,{fetchState:this.state.fetchState},this.props.isLoading),React.createElement(HasError,{fetchState:this.state.fetchState,error:this.state.error},this.props.hasError),React.createElement(IsLoaded,{fetchState:this.state.fetchState,data:this.state.data,params:this.state.params,handleChange:this.handleChange},this.props.isLoaded))}};
window.LazyLoad = class LazyLoad extends React.Component{constructor(e){super(e),this.state={isReady:!1}}componentDidMount(){this.loadScripts(this.props.scripts,this.props.loadScriptsInOrder).then((()=>{this.setState({isReady:!0})}))}loadScripts(e,r){function t(e){return new Promise((function(r){for(var t=document.querySelectorAll("link"),o=0,n=t.length;o<n;o++)if("stylesheet"===t[o].rel&&t[o].getAttribute("href")===e)return void r();var i=document.createElement("link");i.rel="stylesheet",i.onload=r,i.onerror=function(){console.error("Error loading CSS File: "+e),r()},i.href=e,document.head.appendChild(i)}))}function o(e){return new Promise((function(r){for(var t=document.querySelectorAll("script"),o=0,n=t.length;o<n;o++)if(t[o].getAttribute("src")===e)return void r();var i=document.createElement("script");i.onload=r,i.onerror=function(){console.error("Error loading JS File: "+e),r()},i.src=e,document.head.appendChild(i)}))}function n(e){return new Promise((function(r){for(var t=document.querySelectorAll("script[data-src][data-compiler]"),o=0,n=t.length;o<n;o++)if(t[o].getAttribute("data-src")===e)return void r();var i=document.createElement("script");i.type="text/babel",i.setAttribute("src",e),document.head.appendChild(i),jsxLoader.loadScript(i).then((function(){r()}))}))}if("string"==typeof e)e=[e];else if(!Array.isArray(e))return console.error("Invalid prop for <LazyLoad>, expected [scripts] to be a string or an array of strings. Check console."),console.log(e),new Promise((function(e){e()}));return new Promise(!0===r?function(r){var i=0,s=e.length;!function a(){if(i!==s){var d=e[i];i++,d.endsWith(".js")?o(d).then(a):d.endsWith(".css")?t(d).then(a):d.endsWith(".jsx")?n(d).then(a):(console.error("Invalid Script for <LazyLoad>. Only scripts ending with [js, css, or jsx] can be used. Error URL: "+d),a())}else r()}()}:function(r){const i=[];for(let r=0,s=e.length;r<s;r++){const s=e[r];s.endsWith(".js")?i.push(o(s)):s.endsWith(".css")?i.push(t(s)):s.endsWith(".jsx")?i.push(n(s)):console.error("Invalid Script for <LazyLoad>. Only scripts ending with [js, css, or jsx] can be used. Error URL: "+s)}Promise.all(i).then((function(){r()}))})}loadPolyfill(e,r){return new Promise(!1===e||void 0===e?function(e,t){var o,n,i;o=e,n=t,(i=document.createElement("script")).onload=function(){o()},i.onerror=function(){console.error("Error loading Script: "+r),n()},i.src=r,document.head.appendChild(i)}:function(e){e()})}render(){if(!this.state.isReady)return this.props.isLoading?this.props.isLoading:null;if(this.props.children)return this.props.children;if(this.props.isLoaded){if("string"==typeof this.props.isLoaded){var e=this.props.isLoaded,r={};for(var t in this.props)this.props.hasOwnProperty(t)&&"scripts"!==t&&"isLoaded"!==t&&"isLoading"!==t&&(r[t]=this.props[t]);if(void 0!==window&&void 0!==window[e])return React.createElement(window[e],r);if(void 0!==globalThis&&void 0!==globalThis[e])return React.createElement(globalThis[e],r);throw new TypeError("Component <LazyLoad isLoaded="+JSON.stringify(e)+"> was not found. Check if your script is missing or has a compile error.")}return this.props.isLoaded}throw new TypeError("Missing child nodes or the [isLoaded] property for a <LazyLoad> element.")}};
window.SortableTable = class SortableTable extends React.Component{constructor(e){super(e),this.sortColumn=this.sortColumn.bind(this),this.table=React.createRef()}componentDidMount(){this.setupTable()}setupTable(){const e=this.table.current;if(null===e.tHead)return console.warn("Unable to setup sorting for table because there is no <thead> element"),void console.log(e);if(0===e.tHead.rows.length)return console.warn("Unable to setup sorting for table because the <thead> element contained now rows"),void console.log(e);if(0===e.tBodies.length)return console.warn("Unable to setup sorting for table because the <tbody> element is missing"),void console.log(e);if(1!==e.tBodies.length)return console.warn("Unable to setup sorting for table because there can only be one <tbody> element for the table"),void console.log(e);const t=e.tHead.rows[e.tHead.rows.length-1];for(let e=0,l=t.cells.length;e<l;e++)t.cells[e].addEventListener("click",this.sortColumn),t.cells[e].style.cursor="pointer"}sortColumn(e){const t=e.target,l=t&&t.parentElement&&t.parentElement.parentElement?t.parentElement.parentElement.parentElement:null;if("TH"!==t.tagName&&"TD"!==t.tagName)return console.warn("SortableTable.sortColumn() was called with an invalid element. If called manually the cell needs to be passed."),void console.log(t);if(null!=l&&"TABLE"!==l.tagName)return console.warn("SortableTable.sortColumn() was called with an invalid element. If called manually the table cell of the last row from the table header should be used."),void console.log(t);const o=l.getAttribute("data-sort-column"),a=t.cellIndex;let n="asc";if(null!==o&&parseInt(o,10)===a){n="asc"===l.getAttribute("data-sort-order")?"desc":"asc"}const s=l.tBodies[0],r=s.rows,u=[];for(let e=0,t=r.length;e<t;e++){const t=r[e].cells[a];if(void 0===t)continue;const l=t.getAttribute("data-value");let o=null!==l?l.trim():t.textContent.trim(),n=typeof o;if(""===o)o=null;else if(isNaN(o)){const e=new Date(o);isNaN(e.getTime())?o=void 0!==o.toLocaleLowerCase?o.toLocaleLowerCase():o.toLowerCase():(o=e,n="date")}else o=parseFloat(o);u.push({row:r[e],value:o,type:null===o?null:n})}u.sort(this.sortCompare),"desc"===n&&u.reverse();const c=l.getAttribute("data-sort-class-odd"),i=l.getAttribute("data-sort-class-even"),d=c&&i;let p=0;for(let e=0,t=u.length;e<t;e++){const t=u[e].row;d&&"none"!==t.style.display&&(p++,p%2==0?(t.classList.add(i),t.classList.remove(c)):(t.classList.add(c),t.classList.remove(i))),s.appendChild(t)}l.setAttribute("data-sort-column",a),l.setAttribute("data-sort-order",n)}sortCompare(e,t){return null===e.type&&null!==t.type?-1:null===t.type&&null!==e.type?1:null===e.type&&null===t.type?0:"number"===e.type&&"number"!==t.type?-1:"number"===t.type&&"number"!==e.type?1:"number"===e.type&&"number"===t.type?e.value-t.value:"date"===e.type&&"date"!==t.type?-1:"date"===t.type&&"date"!==e.type?1:"date"===e.type&&"date"===t.type?e.value<t.value?-1:e.value>t.value?1:0:"string"===e.type&&"string"===t.type?void 0!==e.value.localeCompare?e.value.localeCompare(t.value):e.value<t.value?-1:e.value>t.value?1:0:(console.warn("A code change from [SortableTable] impacted sorting and caused an expected error so the data may appear out of order. Please review your code changes"),0)}render(){return React.createElement("table",Object.assign({},this.props,{ref:this.table}),this.props.children)}};