// @link https://www.dataformsjs.com
// @version 5.2.0
// @author Conrad Sollitt (https://conradsollitt.com)
// @license MIT
import{Format}from"./utils-format.min.js";import{buildUrl,setElementText,getBindValue,bindAttrTmpl,componentsAreDefined,polyfillCustomElements,showErrorAlert,showError}from"./utils.min.js";const format=new Format,appEvents={contentReady:"app:contentReady",error:"app:error"},shadowTmpl=document.createElement("template");shadowTmpl.innerHTML="\n    <style>\n        :host { display: block; }\n        :host([hidden]) { display: none; }\n    </style>\n    <slot></slot>\n";const dataCache=[];function saveDataToCache(t,e,s){for(const o of dataCache)if(o.url===t)return o.params=JSON.stringify(e),void(o.data=s);dataCache.push({url:t,params:JSON.stringify(e),data:s})}function getDataFromCache(t,e){for(const s of dataCache)if(s.url===t){if(e===s.params||null===e&&"null"===s.params)return s.data;break}return null}function copyTemplateSelector(t){const e=t.getAttribute("template-selector");if(e&&0===t.childNodes.length){const s=document.querySelector(e);s?t.appendChild(s.content.cloneNode(!0)):showError(t,`Error - Could not find template from <${t.tagName.toLowerCase()} [template-selector="${e}"]>.`)}}class JsonData extends HTMLElement{constructor(){super();this.attachShadow({mode:"open"}).appendChild(shadowTmpl.content.cloneNode(!0)),this.state={isLoading:!1,hasError:!1,isLoaded:!1,errorMessage:null},this.handleButtonClick=this.handleButtonClick.bind(this)}static get observedAttributes(){return["url","url-params"]}attributeChangedCallback(t,e){switch(t){case"url":case"url-params":null!==e&&this.fetch()}}connectedCallback(){if(this.elements={isLoading:this.querySelector("is-loading"),hasError:this.querySelector("has-error"),isLoaded:this.querySelector("is-loaded"),clickButton:null},null===this.clickSelector)void 0===this.state||this.state.isLoading||this.state.hasError||this.state.isLoaded||this.fetch();else if(this.elements.clickButton=document.querySelector(this.clickSelector),null===this.elements.clickButton){const t="Element not found for <json-data> Web Component using [click-selector]: "+String(this.clickSelector);showErrorAlert(t)}else this.elements.clickButton.addEventListener("click",this.handleButtonClick)}disconnectedCallback(){this.elements&&null!==this.elements.clickButton&&(this.elements.clickButton.removeEventListener("click",this.handleButtonClick),this.elements.clickButton=null)}handleButtonClick(){"boolean"==typeof this.elements.clickButton.disabled&&(this.elements.clickButton.disabled=!0);const t=document.querySelectorAll("input[data-bind],select[data-bind],textarea[data-bind]"),e={};for(const s of t){const t=s.getAttribute("data-bind");"INPUT"===s.nodeName&&"checkbox"===s.type?e[t]=s.checked:e[t]=s.value}this.setAttribute("url-params",""),this.setAttribute("url-params",JSON.stringify(e))}get url(){return this.getAttribute("url")}get urlParams(){return this.getAttribute("url-params")}get loadOnlyOnce(){return null!==this.getAttribute("load-only-once")}get clickSelector(){return this.getAttribute("click-selector")}get isLoading(){return this.state.isLoading}set isLoading(t){this.state.isLoading=!0===t,this.elements.isLoading&&(this.elements.isLoading.style.display=this.state.isLoading?"":"none")}get hasError(){return this.state.hasError}set hasError(t){this.state.hasError=!0===t,this.elements.hasError&&(this.elements.hasError.style.display=this.state.hasError?"":"none")}get isLoaded(){return this.state.isLoaded}set isLoaded(t){this.state.isLoaded=!0===t,this.elements.isLoaded&&(this.elements.isLoaded.style.display=this.state.isLoaded?"":"none")}dispatchContentReady(){this.dispatchEvent(new Event(appEvents.contentReady,{bubbles:!0}));const t=this.getAttribute("onready");if(t)try{const e=new Function("return "+t)();"function"==typeof e&&e()}catch(e){showErrorAlert(`Error from function <json-data onready="${t}">: ${e.message}`),console.error(e)}}async fetch(){const t=this.url;let e=t;if(null===e||""===e)return await this.showError("Error, element <json-data> is missing attribute [url]"),void this.dispatchContentReady();let s=this.getAttribute("url-params");if(""!==s||!e.includes(":")){if(this.loadOnlyOnce){const e=getDataFromCache(t,s);if(null!==e)return await this._setLoadedState(e),void this.dispatchContentReady()}s&&(s=JSON.parse(s)),e=buildUrl(e,s),this.isLoading=!0,this.isLoaded=!1,this.hasError=!1,await this.bindData(),fetch(e,{mode:"cors",cache:"no-store",credentials:"same-origin"}).then((t=>{const e=t.status;if(e>=200&&e<300||304===e)return Promise.resolve(t);{const s="Error loading data. Server Response Code: "+e+", Response Text: "+t.statusText;return Promise.reject(s)}})).then((t=>t.json())).then((async e=>{this.loadOnlyOnce&&saveDataToCache(t,s,e),await this._setLoadedState(e)})).catch((async t=>{await this.showError(t)})).finally((()=>{null!==this.elements.clickButton&&"boolean"==typeof this.elements.clickButton.disabled&&(this.elements.clickButton.disabled=!1),this.dispatchContentReady()}))}}async showError(t){this.isLoading=!1,this.isLoaded=!1,this.hasError=!0,this.state.errorMessage=t,this.dispatchEvent(new CustomEvent(appEvents.error,{bubbles:!0,detail:t})),await this.bindData(),console.error(t)}async _setLoadedState(t){this.isLoading=!1,this.isLoaded=!0,this.hasError=!1,this.state.errorMessage=null;const e=this.getAttribute("transform-data");if(e)try{if("function"==typeof window[e]){const s=window[e](t);"object"==typeof s&&null!==s?Object.assign(this.state,s):await this.showError(`Function [${e}()] must return an object.`)}else await this.showError(`Function [${e}()] was not found.`)}catch(t){await this.showError(t)}else Object.assign(this.state,t);"boolean"==typeof t.hasError&&(this.hasError=t.hasError),await this.bindData()}async bindData(){await componentsAreDefined(this,"[data-bind]");let t=this.querySelectorAll("[data-bind]");for(const e of t){const t=e.getAttribute("data-bind");let s=""===t?this.state:getBindValue(this.state,t);const o=e.getAttribute("data-format");if(null!==o)if("function"==typeof format[o])s=format[o](s);else if("function"==typeof window[o])try{s=window[o](s)}catch(t){console.error(t),s="Error: "+t.message}else s="Error: Unknown format ["+o+"]";setElementText(e,s)}t=this.querySelectorAll("[data-bind-attr]");for(const e of t)bindAttrTmpl(e,"data-bind-attr",this.state);t=this.querySelectorAll("[data-show]");for(const e of t)if(this.state.isLoading)e.style.display="none";else{const t=e.getAttribute("data-show");try{const s=new Function("state","format","with(state){return "+t+"}")(this.state,format);e.style.display=!0===s?"":"none"}catch(s){e.style.display="",console.error(`Error evaluating JavaScript expression from [data-show="${t}"] attribute.`),console.error(s)}}t=this.querySelectorAll("[data-bind-refresh]");for(const e of t){const t=e.getAttribute("data-bind-refresh");try{e[t]()}catch(s){console.error(`Error calling function from element with [data-bind-refresh="${t}"].`),console.error(s),console.log(e)}}polyfillCustomElements()}}window.customElements.define("json-data",JsonData),window.customElements.define("is-loading",class extends HTMLElement{constructor(){super();this.attachShadow({mode:"open"}).appendChild(shadowTmpl.content.cloneNode(!0))}connectedCallback(){"JSON-DATA"===this.parentNode.nodeName&&!0===this.parentNode.isLoading||(this.style.display="none"),copyTemplateSelector(this)}}),window.customElements.define("has-error",class extends HTMLElement{constructor(){super();this.attachShadow({mode:"open"}).appendChild(shadowTmpl.content.cloneNode(!0))}connectedCallback(){"JSON-DATA"===this.parentNode.nodeName&&!0===this.parentNode.hasError||(this.style.display="none"),copyTemplateSelector(this)}}),window.customElements.define("is-loaded",class extends HTMLElement{constructor(){super();this.attachShadow({mode:"open"}).appendChild(shadowTmpl.content.cloneNode(!0))}connectedCallback(){"JSON-DATA"===this.parentNode.nodeName&&!0===this.parentNode.isLoaded||(this.style.display="none"),copyTemplateSelector(this)}});